<?php

if(!file_exists('../app/config/parameters.yml')){
    copy('../app/config/parameters.yml.dist', '../app/config/parameters.yml');
}

if(!file_exists('../vendor/autoload.php')){
    
    $init = true;

    //still no way to find that executable correctly
    /*$phpExec = 'php';
    
    
    
    if($_REQUEST['doInit'] == 1){
        
        $exec = $_REQUEST['exec'];
        
        $path = realpath( __DIR__.'/../');
        $cmd = $exec.' -d allow_url_fopen=1 -d memory_limit=-1 -d safe_mode=off ./composer.phar install';

        putenv('COMPOSER_HOME='.$path);
        exec('cd ' . $path . '; ' . $cmd .' 2>&1',$output,$returnCode);

        if( $returnCode == 0 ){
            $result = array('success' => true, 'command' => $cmd, 'code' => $returnCode, 'output' => implode("\n", $output) ) ;
        }else{
            $result = array('success' => false, 'command' => $cmd,'code' => $returnCode, 'output' => implode("\n", $output) );
        }
        
        header('Content-Type: application/json');
        echo json_encode($result);
        exit();
        
    }*/
    
}else{

    $loader = require_once __DIR__.'/../app/bootstrap.php.cache';


    if (!isset($_SERVER['HTTP_HOST'])) {
        exit('This script cannot be run from the CLI. Run it from a browser.');
    }

    require_once dirname(__FILE__).'/../app/SymfonyRequirements.php';

    $symfonyRequirements = new SymfonyRequirements();

    $symfonyRequirements->addRequirement(
        extension_loaded('soap'),
        'soap extension must be enabled',
        'Install and enable the <strong>SOAP</strong> extension.'
    );

    $symfonyRequirements->addRequirement(
        function_exists('bcadd'),
        'bcmath extension must be enabled',
        'Install and enable the <strong>bcmath</strong> extension.'
    );

    $majorProblems = $symfonyRequirements->getFailedRequirements();
    $minorProblems = $symfonyRequirements->getFailedRecommendations();

}


function command_exist($cmd) {
    $return = shell_exec(sprintf("which %s", escapeshellarg($cmd)));
    return !empty($return);
}



?>
<style>
#logo {
    width: auto!important;
}
#logo-group>span {
    height:auto!important;
}
#logo img {
    max-height: 100%!important;
    width:100%!important;
}
#header>:first-child, aside {
    width: auto!important;
}
#main form{
    margin: 0;
}
#header{
    height: unset!important;
}

</style>
<!DOCTYPE html>
<html>
    <head>
        <meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
        <meta name="robots" content="noindex,nofollow" />
        <title>Warexo Installation</title>
        <link rel="stylesheet" href="https://neu.warexo.de/css/fontawesome6.min.css">
        <script src="https://kit.fontawesome.com/f049c80ee2.js" crossorigin="anonymous"></script>
        <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.0.2/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-EVSTQN3/azprG1Anm3QDgpJLIm9Nao0Yz1ztcQTwFspd3yD65VohhpuuCOmLASjC" crossorigin="anonymous">
       
    </head>

    <body class="animated fadeInDown" style="font-size:16px">


        <div id="header" class="header">
            <div class="container">
                <div class="row">

                    <div id="logo col-6 p-3">
                        
                            <svg version="1.1" style="max-height:75px; padding:1rem;" viewBox="0 0 178.3 30.089" xml:space="preserve" xmlns="http://www.w3.org/2000/svg" xmlns:cc="http://creativecommons.org/ns#" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"><metadata><rdf:RDF><cc:Work rdf:about=""><dc:format>image/svg+xml</dc:format><dc:type rdf:resource="http://purl.org/dc/dcmitype/StillImage"/><dc:title/></cc:Work></rdf:RDF></metadata><g transform="matrix(1.3333 0 0 -1.3333 0 30.089)"><g transform="translate(133.72 3.8672)"><path d="m0 0c0-2.137-1.73-3.867-3.865-3.867h-99.039c-2.136 0-3.867 1.73-3.867 3.867v14.834c0 2.135 1.731 3.866 3.867 3.866h99.039c2.135 0 3.865-1.731 3.865-3.866z" fill="#36342c"/></g><g transform="translate(34.583)"><path d="m0 0h-30.717c-2.136 0-3.866 1.73-3.866 3.867v14.835c0 2.134 1.73 3.865 3.866 3.865h30.717" fill="#ed6a4c"/></g><g transform="translate(42.075 10.039)"><path d="m0 0-2.091-4.946h-2.584l-4.47 11.558h2.566l3.4-8.889 2.142 5.099-1.428 3.79h2.584l3.093-8.499 3.332 8.499h2.601l-4.606-11.558h-2.584z" fill="#ed6a4c"/></g><g transform="translate(55.063,9.1724)"><path d="m0 0h4.045l-1.971 5.116zm0.68 7.479h2.788l4.47-11.559h-2.414l-0.883 2.311h-5.253l-0.901-2.311h-2.414z" fill="#ed6a4c"/></g><g transform="translate(67.506 14.577)"><path d="m0 0v-3.451h2.958c1.088 0 1.869 0.646 1.869 1.717 0 1.139-0.781 1.734-1.869 1.734zm-2.38 2.074h5.083c2.838 0 4.607-1.156 4.607-3.757 0-1.836-1.31-3.195-3.043-3.552l3.688-3.859v-0.391h-2.669l-3.858 4.165h-1.428v-4.165h-2.38z" fill="#ed6a4c"/></g><g transform="translate(77.809 5.0923)"><path d="m0 0v11.559h9.145v-2.091h-6.868v-2.499h5.627v-2.09h-5.627v-2.788h6.868v-2.091z" fill="#ed6a4c"/></g><g transform="translate(100.15 16.481)"><path d="m0 0-4.113-5.626 4.113-5.576v-0.187h-2.754l-3.025 4.199-3.027-4.199h-2.753v0.187l4.097 5.576-4.097 5.626v0.17h2.737l3.043-4.232 3.059 4.232h2.72z" fill="#fff"/></g><g transform="translate(107.18 7.1489)"><path d="m0 0c2.125 0 3.604 1.615 3.604 3.706 0 2.125-1.479 3.706-3.604 3.706-2.091 0-3.604-1.581-3.604-3.706 0-2.091 1.513-3.706 3.604-3.706m-0.017 9.672c3.417 0 5.966-2.549 5.966-5.966 0-3.383-2.549-5.933-5.966-5.933-3.382 0-5.932 2.55-5.932 5.933 0 3.417 2.55 5.966 5.932 5.966" fill="#fff"/></g><path d="m5.71 16.756h1.518v-10.995h-1.518z" fill="#fff"/><path d="m8.745 16.756h1.518v-10.995h-1.518z" fill="#fff"/><g transform="translate(13.337 16.671)"><path d="m0 0h-1.559v-10.909h3.035v10.909z" fill="#fff"/></g><path d="m16.33 16.823h1.518v-11.115h-1.518z" fill="#fff"/><path d="m115.71 16.756h1.518v-10.995h-1.518z" fill="#fff"/><path d="m118.74 16.756h1.518v-10.995h-1.518z" fill="#fff"/><g transform="translate(123.34 16.671)"><path d="m0 0h-1.559v-10.909h3.034v10.909z" fill="#fff"/></g><path d="m126.33 16.823h1.518v-11.115h-1.518z" fill="#fff"/><g transform="translate(20.84 16.823)"><path d="m0 0h1.559v-11.115h-3.035v11.115z" fill="#fff"/></g><path d="m23.917 16.823h1.518v-11.089h-1.518z" fill="#fff"/><g transform="translate(28.509 16.823)"><path d="m0 0h-1.558v-11.089h3.035v11.089z" fill="#fff"/></g></g></svg>
                     

                        </div>
                </div>
            </div>

        </div>

        <div id="main" role="main">

            <!-- MAIN CONTENT -->
            <div id="content" class="container">

                <div class="row">
                    
                    <section id="widget-grid">
                        <div class="row">
                            <article class="col-sm-12 col-md-12 col-lg-12">
                                <div class="card mb-3">
                                
                                        <div class="card-header dark-bg">
                                            <h4>Schritt 1. Systemvoraussetzungen Prüfen</h4>
                                            <span class="small">überprüfen ob Ihr System die Voraussetzungen erfüllt um Warexo zu installieren</span>
                                           
                                  
                            </div>
                                    <div role="content">
                                        <div class="card-body">
                           
                                        
                                   
                                            
                                                
                                                <p class="alert-info p-3"> In diesem Schritt wird überprüft, ob Ihr System die Voraussetzungen erfüllt.
                                                Der Installationsassistent lädt beim ersten Start die benötigten Pakete der Drittanbieter herunter, dieser Vorgang kann einige Zeit in Anspruch nehmen. Sollte eine Fehlermeldung erscheinen installieren Sie bitte die Drittanbieter Pakete manuell.
                                                     <!-- This script will guide you through the basic configuration of your project.-->
                                                </p>
                                                <p>
                                                <i class="fa-solid fa-square-check text-success"></i> - Die Voraussetzung ist erfüllt<br />
                                                <i class="fa-solid fa-square-check text-warning"></i> - Die Voraussetzung ist nicht oder nur Teilweise erfüllt. Warexo funktioniert trotzdem und kann installiert werden <br />
                                                <i class="fa-solid fa-square-minus text-danger"></i> - Die Voraussetzung ist nicht erfüllt. Warexo kann nicht installiert werden <br />
                                                <i class="fa-solid fa-circle-question"></i> -Die Voraussetzung konnte nicht überprüft werden
                                            </p>
                                               

                                                

                                                

                                                
                                        </div>
                                  
                                        
                                    </div>
                          

                                           
                                </div>
<div class="row">

    <div class="col-4">                           
        <div class="card h-100">
        <div class="card-header">Systemvoraussetzungen</div>
            <div class="card-body small">
                <ul class="list-unstyled"> 
                    <li>
                        <i class="fa-solid fa-square-check text-success"></i> 
                        <?php echo $_SERVER['SERVER_SOFTWARE'];?>
                    </li>
                    <li class="text-truncate"><i class="fa-solid fa-square-check text-success"></i>
                        <?php ob_start();
                        phpinfo(INFO_MODULES);
                        $info = ob_get_contents();
                        ob_end_clean();
                        $info = stristr($info, 'Client API version');
                        preg_match('/[1-9].[0-9].[1-9][0-9]/', $info, $match);
                        $gd = $match[0];
                        $gd = exec("mysql --version");
                        echo 'MySQL:  '.$gd; ?>
                    </li>
                    <li>
                        <i class="fa-solid fa-square-check text-success"></i> 
                        <?php echo 'PHP Version: ' . phpversion();?>
                    </li>
                    <li>
                        <?php if (!function_exists("json_decode")) echo '<i class="fa-solid fa-square-minus text-danger"></i> JSON nicht installiert' ?>
                        <?php if (function_exists("json_decode")) echo '<i class="fa-solid fa-square-check text-success"></i> JSON' ?>
                    </li>
                    
                    <li>
                        <?php if (!function_exists("ctype_alnum")) echo '<i class="fa-solid fa-square-minus text-danger"></i> ctype nicht installiert'  ?>
                        <?php if (function_exists("ctype_alnum")) echo '<i class="fa-solid fa-square-check text-success"></i> ctype' ?>
                     
                    </li>
                    <li>
                        <?php if (!class_exists("SoapClient")) echo '<i class="fa-solid fa-square-minus text-danger"></i> SOAP nicht installiert'  ?>
                        <?php if (class_exists("SoapClient")) echo '<i class="fa-solid fa-square-check text-success"></i> SOAP' ?>
                        
                    </li>
                    <li>
                        <?php if (!function_exists("curl_exec")) echo '<i class="fa-solid fa-square-minus text-danger"></i> CURL nicht installiert'  ?>
                        <?php if (function_exists("curl_exec")) echo '<i class="fa-solid fa-square-check text-success"></i> CURL' ?>
                     
                    </li>
                    <li>
                        <?php if (!function_exists("passthru")) echo '<i class="fa-solid fa-square-minus text-warning"></i> passthru nicht aktiviert'  ?>
                        <?php if (function_exists("passthru")) echo '<i class="fa-solid fa-square-check text-success"></i> passthru aktiviert' ?>
                    </li>
                    
                    <li>
                        <?php if (!command_exist('soffice')) : ?>
                            <i class="fa-solid fa-square-minus text-danger"></i>
                        <?php else: ?>
                            <i class="fa-solid fa-square-check text-success"></i>
                        <?php endif; ?>
                        LibreOffice 
                    </li>
                    <li>                      
                        <?php if (!function_exists("ftp_connect")) echo '<i class="fa-solid fa-square-minus text-danger"></i> FTP Extension nicht installiert'  ?>
                        <?php if (function_exists("ftp_connect")) echo '<i class="fa-solid fa-square-check text-success"></i> FTP Extension installiert' ?>
                   </li>
                    <li><i class="fa-solid fa-square-check text-success"></i><?php if ($_SERVER['HTTPS'] != "on") echo "SSL-Zertifikat nicht installiert" ?> SSL-Zertifikat auf dem Server (z.B. Lets Encrypt) installiert.</li>

                    <li>
                        <?php if (!function_exists("exec")) echo '<i class="fa-solid fa-square-minus text-danger"></i> EXEC nicht installiert'  ?>
                        <?php if (function_exists("exec")) echo '<i class="fa-solid fa-square-check text-success"></i> PHP exec Funktion erlaubt, Programme im <code>$PATH</code>:' ?>

                        <ul>
                            <li>
                                <?php if (!command_exist('mysqldump')) : ?>
                                    <i class="fa-solid fa-square-minus text-danger"></i>
                                <?php else: ?>
                                    <i class="fa-solid fa-square-check text-success"></i>
                                <?php endif; ?>

                                mysqldump
                            </li>
                            <li>
                                <?php if (!command_exist('wget')) : ?>
                                    <i class="fa-solid fa-square-minus text-danger"></i>
                                <?php else: ?>
                                    <i class="fa-solid fa-square-check text-success"></i>
                                <?php endif; ?>

                                wget
                            </li>
                            <li>
                                <?php if (!command_exist('unzip')) : ?>
                                    <i class="fa-solid fa-square-minus text-danger"></i>
                                <?php else: ?>
                                    <i class="fa-solid fa-square-check text-success"></i>
                                <?php endif; ?>

                                unzip
                            </li>
                            <li>
                                <?php if (!command_exist('rm')) : ?>
                                    <i class="fa-solid fa-square-minus text-danger"></i>
                                <?php else: ?>
                                    <i class="fa-solid fa-square-check text-success"></i>
                                <?php endif; ?>

                                rm
                            </li>
                            <li>
                                <?php if (!command_exist('grep')) : ?>
                                    <i class="fa-solid fa-square-minus text-danger"></i>
                                <?php else: ?>
                                    <i class="fa-solid fa-square-check text-success"></i>
                                <?php endif; ?>

                                grep
                            </li>
                        </ul>
                     </li>
                </ul>
            </div>
        </div>
    </div>
    <div class="col-4">                           
        <div class="card h-100">
        <div class="card-header">Empfohlene Einstellungen</div>
            <div class="card-body small">
                <ul class="list-unstyled"> 
                    <li>
                        <?php if (!extension_loaded('xml')) echo '<i class="fa-solid fa-square-minus text-warning"></i> PHP-XML nicht installiert'  ?>
                        <?php if (extension_loaded('xml')) echo '<i class="fa-solid fa-square-check text-success"></i> PHP-XML Modul installiert' ?>  
                    </li>
                    <li><i class="fa-solid fa-square-check text-success"></i> Sie sollten mindestens version 2.6.21 von libxml haben</li>
                    <li>
                        <?php if (!function_exists("ftp_connect")) echo '<i class="fa-solid fa-square-minus text-warning"></i> Tokenizer nicht aktiviert'  ?>
                        <?php if (function_exists("ftp_connect")) echo '<i class="fa-solid fa-square-check text-success"></i> PHP tokenizer aktiviert.' ?>                      
                    </li>
                    <li>
                        <?php if (!extension_loaded('mbstring')) echo '<i class="fa-solid fa-square-minus text-warning"></i> mbstring nicht aktiviert'  ?>
                        <?php if (extension_loaded('mbstring')) echo '<i class="fa-solid fa-square-check text-success"></i> mbstring Funktionen aktiviert' ?>  
                    </li>
                    <li>
                        <?php if (!extension_loaded('iconv')) echo '<i class="fa-solid fa-square-minus text-warning"></i> iconv nicht aktiviert'  ?>
                        <?php if (extension_loaded('iconv')) echo '<i class="fa-solid fa-square-check text-success"></i> iconv aktiviert' ?>  
                    </li>
                    <li>
                        <?php if (!extension_loaded('posix')) echo '<i class="fa-solid fa-square-minus text-warning"></i> POSIX nicht aktiviert sollte es aber'  ?>
                        <?php if (extension_loaded('posix')) echo '<i class="fa-solid fa-square-check text-success"></i> POSIX aktiviert (nur für Unix, Linux Systeme)' ?>  
                    </li>
                    <li>
                        <?php if (!extension_loaded('intl')) echo '<i class="fa-solid fa-square-minus text-warning"></i> Intl sollte installiert sein mit ICU 4+'  ?>
                        <?php if (extension_loaded('intl')) echo '<i class="fa-solid fa-square-check text-success"></i> Intl installiert mit ICU 4+' ?>  
                    </li>
                    <li>
                        <?php if (!function_exists("apcu_add")) echo '<i class="fa-solid fa-square-minus text-warning"></i> APC nicht aktiviert'  ?>
                        <?php if (function_exists("apcu_add")) echo '<i class="fa-solid fa-square-check text-success"></i> APC 3.0.17+ (oder ein anderer opcode cache)' ?>
                    </li>
                    <li class="fw-bold p-2 alert-info mt-2 mb-2"> php.ini Einstellungen</li>
                    <li>
                        <?php if (ini_get('max_input_vars') < 10000) echo '<i class="fa-solid fa-square-check text-warning"></i> <code>max_input_vars</code> sollte größer 10000 sein' ?> 
                        <?php if (ini_get('max_input_vars') >= 10000) echo '<i class="fa-solid fa-square-check text-success"></i> <code>max_input_vars</code> größer als 10000' ?>
                    </li>                     
                    <li>
                        <?php if (!ini_get('date.timezone')) echo '<i class="fa-solid fa-square-minus text-danger"></i> <code>date.timezone</code> nicht gesetzt' ?>
                        <?php if (ini_get('date.timezone')) echo '<i class="fa-solid fa-square-check text-success"></i> <code>date.timezone</code> gesetzt auf <code>' . ini_get('date.timezone') . '</code>' ?>
                    </li>                
                   
                </ul>
            </div>
        </div>
    </div>
    <div class="col-4">                           
        <div class="card h-100">
        <div class="card-header">Empfohlene Hardware</div>
            <div class="card-body">
                <ul class="list-unstyled"> 
                    <li><i class="fa-solid fa-microchip"></i> CPU 4 Kerne</li>
                    <li><i class="fa-solid fa-memory"></i> RAM 16 GB</li>
                    <li><i class="fa-solid fa-hard-drive"></i> HDD SSD wenn möglich</li>
                    <div class="alert-warning p-3 small mt-3">
                        <span class="h4">Hinweis!</span> <br />Wir empfehlen einen eigenen dedizierten Server für den Betrieb von Warexo zu verwenden - statistische Auswertungen, Massenverarbeitungen und rechenintensive Operationen können schwache Systeme verlangsamen.
                    </div>
                </ul>
            </div>
        </div>
    </div>
    <div class="col-12">
    <div class="card mt-3 mb-5 ">
        <div class="card-header">Ihre derzeitige Hardware</div>
            <div class="card-body small">  
                    <div class="row"> 
                     
                        <div class="col-3">  
                         <strong>System Information:</strong> <br />
                        <?php system("uname -a"); ?>
                        </div>
                        <div class="col-3">               
                         <strong>Arbeitspeicher:</strong> <br />
                            
                            <?php
                                unset($output);
                                exec('free | grep "Mem:" | tr -s " " | cut -d " " -f2', $output);
                                echo round(floatval($output[0]) / pow(1024, 2), 2) . ' GB';
                            ?>
                    </div>
                    
                    <div class="col-3">    
                        <strong>CPU Information:</strong><br />
                        <?php system("cat /proc/cpuinfo | grep \"model name\" | head -1"); ?>
                    </div>
                    <div class="col-3">    
                    <strong>Verfügbarer Festplattenplatz:</strong><br />
                    	
                   	
<?php echo round(disk_free_space(__FILE__) / pow(1024, 3), 2); ?> GB


                  
                    </div>
                   
                  </div>
                </div>
            </div>
        </div>
    </div>

</div>
                            </article>
                        </div>
                    </section>
                    
                </div>
            </div>
          
        </div>
<div class="footer bg-dark text-light">
    <div class="container p-2 mt-auto">
    © 2021 <a href="https://www.aggrosoft.de" target="_blank" class="btn-link text-light">Aggrosoft GmbH</a> | <a href="https://www.warexo.de" target="_blank" class="btn-link text-light">Warexo.de</a> | <a href="https://www.warexo.de/impressum" target="_blank" class="btn-link text-light">Impressum</a> <a href="https://docs.warexo.de/Installation/index.html" target="_blank" class="btn btn-md btn-success float-right mb-2"> Dokumentation</a>
    </div>
</div>
    </body>
</html>
